﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Task13;

namespace Task13.Migrations
{
    [DbContext(typeof(MovieDbContext))]
    [Migration("20200830155625_InitialMigration")]
    partial class InitialMigration
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.7")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Task13.Models.Actor", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Biography")
                        .HasColumnType("nvarchar(max)");

                    b.Property<DateTime>("Dob")
                        .HasColumnType("datetime2");

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Gender")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Picture")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("PlaceOfBirth")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Actor");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Biography = "Great Actor, likes movies",
                            Dob = new DateTime(1963, 2, 17, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            FirstName = "John",
                            Gender = "Male",
                            LastName = "Johnson",
                            Picture = " :/",
                            PlaceOfBirth = "USA"
                        },
                        new
                        {
                            Id = 2,
                            Biography = "Great Actor",
                            Dob = new DateTime(1990, 2, 17, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            FirstName = "Irfan",
                            Gender = "Male",
                            LastName = "Nazand",
                            Picture = " :/",
                            PlaceOfBirth = "USA"
                        });
                });

            modelBuilder.Entity("Task13.Models.Character", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Alias")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("FullName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Gender")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Picture")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Character");
                });

            modelBuilder.Entity("Task13.Models.Franchise", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Description")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Franchise");
                });

            modelBuilder.Entity("Task13.Models.Movie", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Director")
                        .HasColumnType("nvarchar(max)");

                    b.Property<int?>("FranchiseId")
                        .HasColumnType("int");

                    b.Property<string>("Genre")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("MovieTitle")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Picture")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ReleaseYear")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Trailer")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.HasIndex("FranchiseId");

                    b.ToTable("Movie");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Director = "Irfan Nazand",
                            Genre = "Documentary",
                            MovieTitle = "Micheal Jordan: AutoBiography",
                            Picture = "No picture",
                            ReleaseYear = "2019",
                            Trailer = "Coming Soon"
                        },
                        new
                        {
                            Id = 3,
                            Director = "Irfan Nazand",
                            Genre = "Documentary",
                            MovieTitle = "Cristiano Ronaldo: AutoBiography",
                            Picture = "No picture",
                            ReleaseYear = "2020",
                            Trailer = "Coming Soon"
                        },
                        new
                        {
                            Id = 4,
                            Director = "Irfan Nazand",
                            Genre = "Documentary",
                            MovieTitle = "Lionel Messi: AutoBiography",
                            Picture = "No picture",
                            ReleaseYear = "2015",
                            Trailer = "Coming Soon"
                        },
                        new
                        {
                            Id = 5,
                            Director = "Irfan Nazand",
                            Genre = "Documentary",
                            MovieTitle = "Robert Lewandowski: AutoBiography",
                            Picture = "No picture",
                            ReleaseYear = "2011",
                            Trailer = "Coming Soon"
                        });
                });

            modelBuilder.Entity("Task13.Models.MovieCharacter", b =>
                {
                    b.Property<int>("MovieId")
                        .HasColumnType("int");

                    b.Property<int>("CharacterId")
                        .HasColumnType("int");

                    b.Property<int?>("ActorId")
                        .HasColumnType("int");

                    b.HasKey("MovieId", "CharacterId");

                    b.HasIndex("ActorId");

                    b.HasIndex("CharacterId");

                    b.ToTable("MovieCharacter");
                });

            modelBuilder.Entity("Task13.Models.Movie", b =>
                {
                    b.HasOne("Task13.Models.Franchise", "Franchise")
                        .WithMany("Movies")
                        .HasForeignKey("FranchiseId");
                });

            modelBuilder.Entity("Task13.Models.MovieCharacter", b =>
                {
                    b.HasOne("Task13.Models.Actor", "Actor")
                        .WithMany("MovieCharacters")
                        .HasForeignKey("ActorId");

                    b.HasOne("Task13.Models.Character", "Character")
                        .WithMany("MovieCharacters")
                        .HasForeignKey("CharacterId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Task13.Models.Movie", "Movie")
                        .WithMany("MovieCharacters")
                        .HasForeignKey("MovieId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
